OpenShot Audio Library | OpenShotAudio: juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

`#include <juce_ReferenceCountedArray.h>`

## Public Types
using | ObjectClassPtr = ReferenceCountedObjectPtr< ObjectClass >
using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

## Public Member Functions
| ReferenceCountedArray ()=default
| ReferenceCountedArray (const ReferenceCountedArray &other) noexcept
| ReferenceCountedArray (ReferenceCountedArray &&other) noexcept
template<class OtherObjectClass , class OtherCriticalSection >
| ReferenceCountedArray (const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > &other) noexcept
ReferenceCountedArray & | operator= (const ReferenceCountedArray &other) noexcept
template<class OtherObjectClass >
ReferenceCountedArray & | operator= (const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > &other) noexcept
ReferenceCountedArray & | operator= (ReferenceCountedArray &&other) noexcept
| ~ReferenceCountedArray ()
void | clear ()
void | clearQuick ()
int | size () const noexcept
bool | isEmpty () const noexcept
ObjectClassPtr | operator[] (int index) const noexcept
ObjectClassPtr | getUnchecked (int index) const noexcept
ObjectClass * | getObjectPointer (int index) const noexcept
ObjectClass * | getObjectPointerUnchecked (int index) const noexcept
ObjectClassPtr | getFirst () const noexcept
ObjectClassPtr | getLast () const noexcept
ObjectClass ** | getRawDataPointer () const noexcept
ObjectClass ** | begin () noexcept
ObjectClass *const * | begin () const noexcept
ObjectClass ** | end () noexcept
ObjectClass *const * | end () const noexcept
ObjectClass ** | data () noexcept
ObjectClass *const * | data () const noexcept
int | indexOf (const ObjectClass *objectToLookFor) const noexcept
int | indexOf (const ObjectClassPtr &objectToLookFor) const noexcept
bool | contains (const ObjectClass *objectToLookFor) const noexcept
bool | contains (const ObjectClassPtr &objectToLookFor) const noexcept
ObjectClass * | add (ObjectClass *newObject)
ObjectClass * | add (const ObjectClassPtr &newObject)
ObjectClass * | insert (int indexToInsertAt, ObjectClass *newObject)
ObjectClass * | insert (int indexToInsertAt, const ObjectClassPtr &newObject)
bool | addIfNotAlreadyThere (ObjectClass *newObject)
bool | addIfNotAlreadyThere (const ObjectClassPtr &newObject)
void | set (int indexToChange, ObjectClass *newObject)
void | set (int indexToChange, const ObjectClassPtr &newObject)
void | addArray (const ReferenceCountedArray &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1) noexcept
template<class ElementComparator >
int | addSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
template<class ElementComparator >
void | addOrReplaceSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
template<class ElementComparator >
int | indexOfSorted (ElementComparator &comparator, const ObjectClass *objectToLookFor) const noexcept
void | remove (int indexToRemove)
ObjectClassPtr | removeAndReturn (int indexToRemove)
void | removeObject (ObjectClass *objectToRemove)
void | removeObject (const ObjectClassPtr &objectToRemove)
void | removeRange (int startIndex, int numberToRemove)
void | removeLast (int howManyToRemove=1)
void | swap (int index1, int index2) noexcept
void | move (int currentIndex, int newIndex) noexcept
template<class OtherArrayType >
void | swapWith (OtherArrayType &otherArray) noexcept
bool | operator== (const ReferenceCountedArray &other) const noexcept
bool | operator!= (const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > &other) const noexcept
template<class ElementComparator >
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false) noexcept
void | minimiseStorageOverheads () noexcept
void | ensureStorageAllocated (const int minNumElements)
const TypeOfCriticalSectionToUse & | getLock () const noexcept

## Static Public Member Functions
static void | releaseObject (ObjectClass *o)

## Public Attributes
JUCE_DEPRECATED_WITH_BODY(void swapWithArray(ReferenceCountedArray &other) noexcept, { swapWith(other);}) private void | releaseAllObjects ()

## Detailed Description

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
class juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >

Holds a list of objects derived from ReferenceCountedObject, or which implement basic reference-count handling methods.

The template parameter specifies the class of the object you want to point to - the easiest way to make a class reference-countable is to simply make it inherit from ReferenceCountedObject or SingleThreadedReferenceCountedObject, but if you need to, you can roll your own reference-countable class by implementing a set of methods called incReferenceCount(), decReferenceCount(), and decReferenceCountWithoutDeleting(). See ReferenceCountedObject for examples of how these methods should behave.

A ReferenceCountedArray holds objects derived from ReferenceCountedObject, and takes care of incrementing and decrementing their ref counts when they are added and removed from the array.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  Array, OwnedArray, StringArray

Definition at line 50 of file juce_ReferenceCountedArray.h.

## Member Typedef Documentation

## ◆ ObjectClassPtr

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ObjectClassPtr = ReferenceCountedObjectPtr<ObjectClass>

Definition at line 53 of file juce_ReferenceCountedArray.h.

## ◆ ScopedLockType

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array

Definition at line 875 of file juce_ReferenceCountedArray.h.

## Constructor & Destructor Documentation

## ◆ ReferenceCountedArray() [1/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( |  | ) |
| default

Creates an empty array.

See also
  ReferenceCountedObject, Array, OwnedArray

## ◆ ReferenceCountedArray() [2/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| inlinenoexcept

Creates a copy of another array

Definition at line 62 of file juce_ReferenceCountedArray.h.

## ◆ ReferenceCountedArray() [3/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| inlinenoexcept

Moves from another array

Definition at line 73 of file juce_ReferenceCountedArray.h.

## ◆ ReferenceCountedArray() [4/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ReferenceCountedArray | ( | const ReferenceCountedArray< OtherObjectClass, OtherCriticalSection > & | other | ) |
| inlinenoexcept

Creates a copy of another array

Definition at line 80 of file juce_ReferenceCountedArray.h.

## ◆ ~ReferenceCountedArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::~ReferenceCountedArray | ( |  | ) |
| inline

Destructor. Any objects in the array will be released, and may be deleted if not referenced from elsewhere.

Definition at line 123 of file juce_ReferenceCountedArray.h.

## Member Function Documentation

## ◆ add() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | const ObjectClassPtr & | newObject | ) |
| inline

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

Definition at line 372 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add().

## ◆ add() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | ObjectClass * | newObject | ) |
| inline

Appends a new object to the end of the array.

This will increase the new object's reference count.

Parameters

  newObject | the new object to add to the array

See also
  set, insert, addIfNotAlreadyThere, addSorted, addArray

Definition at line 354 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere(), juce::dsp::FilterDesign< FloatType >::designIIRHighpassHighOrderButterworthMethod(), juce::dsp::FilterDesign< FloatType >::designIIRLowpassHalfBandPolyphaseAllpassMethod(), and juce::dsp::FilterDesign< FloatType >::designIIRLowpassHighOrderButterworthMethod().

## ◆ addArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |
| inlinenoexcept

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

Definition at line 498 of file juce_ReferenceCountedArray.h.

## ◆ addIfNotAlreadyThere() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | const ObjectClassPtr & | newObject | ) |
| inline

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

Definition at line 439 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere().

## ◆ addIfNotAlreadyThere() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere | ( | ObjectClass * | newObject | ) |
| inline

Appends a new object at the end of the array as long as the array doesn't already contain it.

If the array already contains a matching object, nothing will be done.

Parameters

  newObject | the new object to add to the array

Returns
  true if the object has been added, false otherwise

Definition at line 420 of file juce_ReferenceCountedArray.h.

## ◆ addOrReplaceSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject
| ) |  |
| inlinenoexcept

Inserts or replaces an object in the array, assuming it is sorted.

This is similar to addSorted, but if a matching element already exists, then it will be replaced by the new one, rather than the new one being added as well.

Definition at line 542 of file juce_ReferenceCountedArray.h.

## ◆ addSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted | ( | ElementComparator & | comparator,
|  | ObjectClass * | newObject
| ) |  |
| inlinenoexcept

Inserts a new object into the array assuming that the array is sorted.

This will use a comparator to find the position at which the new object should go. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator object to use to compare the elements - see the sort() method for details about this object's form
  newObject | the new object to insert to the array

Returns
  the index at which the new object was added

See also
  add, sort

Definition at line 528 of file juce_ReferenceCountedArray.h.

## ◆ begin() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 251 of file juce_ReferenceCountedArray.h.

## ◆ begin() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) |
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 243 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data().

## ◆ clear()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear | ( |  | ) |
| inline

Removes all objects from the array. Any objects in the array whose reference counts drop to zero will be deleted.

Definition at line 132 of file juce_ReferenceCountedArray.h.

## ◆ clearQuick()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick | ( |  | ) |
| inline

Removes all objects from the array without freeing the array's allocated storage. Any objects in the array that whose reference counts drop to zero will be deleted.

See also
  clear

Definition at line 143 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear().

## ◆ contains() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClass * | objectToLookFor | ) | const
| inlinenoexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

Definition at line 323 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere().

## ◆ contains() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClassPtr & | objectToLookFor | ) | const
| inlinenoexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

Definition at line 345 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains().

## ◆ data() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with the standard C++ containers.

Definition at line 283 of file juce_ReferenceCountedArray.h.

## ◆ data() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) |
| inlinenoexcept

Returns a pointer to the first element in the array. This method is provided for compatibility with the standard C++ containers.

Definition at line 275 of file juce_ReferenceCountedArray.h.

## ◆ end() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the element which follows the last element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 267 of file juce_ReferenceCountedArray.h.

## ◆ end() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) |
| inlinenoexcept

Returns a pointer to the element which follows the last element in the array. This method is provided for compatibility with standard C++ iteration mechanisms.

Definition at line 259 of file juce_ReferenceCountedArray.h.

## ◆ ensureStorageAllocated()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated | ( | const int | minNumElements | ) |
| inline

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

Definition at line 861 of file juce_ReferenceCountedArray.h.

## ◆ getFirst()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the first object in the array.

This will return a null pointer if the array's empty.

See also
  getLast

Definition at line 213 of file juce_ReferenceCountedArray.h.

## ◆ getLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the last object in the array.

This will return a null pointer if the array's empty.

See also
  getFirst

Definition at line 224 of file juce_ReferenceCountedArray.h.

## ◆ getLock()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

const TypeOfCriticalSectionToUse & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock | ( |  | ) | const
| inlinenoexcept

Returns the CriticalSection that locks this array. To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Definition at line 872 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointer(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointerUnchecked(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::move(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator==(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith().

## ◆ getObjectPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointer | ( | int | index | ) | const
| inlinenoexcept

Returns a raw pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

Definition at line 193 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[]().

## ◆ getObjectPointerUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getObjectPointerUnchecked | ( | int | index | ) | const
| inlinenoexcept

Returns a raw pointer to the object at this index in the array, without checking whether the index is in-range.

Definition at line 202 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked().

## ◆ getRawDataPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getRawDataPointer | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the actual array data. This pointer will only be valid until the next time a non-const method is called on the array.

Definition at line 234 of file juce_ReferenceCountedArray.h.

## ◆ getUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked | ( | int | index | ) | const
| inlinenoexcept

Returns a pointer to the object at this index in the array, without checking whether the index is in-range.

This is a faster and less safe version of operator[] which doesn't check the index passed in, so it can be used when you're sure the index is always going to be legal.

Definition at line 180 of file juce_ReferenceCountedArray.h.

## ◆ indexOf() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClass * | objectToLookFor | ) | const
| inlinenoexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

Definition at line 294 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject().

## ◆ indexOf() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClassPtr & | objectToLookFor | ) | const
| inlinenoexcept

Finds the index of the first occurrence of an object in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

Definition at line 316 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf().

## ◆ indexOfSorted()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted | ( | ElementComparator & | comparator,
|  | const ObjectClass * | objectToLookFor
| ) |  | const
| inlinenoexcept

Finds the index of an object in the array, assuming that the array is sorted.

This will use a comparator to do a binary-chop to find the index of the given element, if it exists. If the array isn't sorted, the behaviour of this method will be unpredictable.

Parameters

  comparator | the comparator to use to compare the elements - see the sort() method for details about the form this object should take
  objectToLookFor | the object to search for

Returns
  the index of the element, or -1 if it's not found

See also
  addSorted, sort

Definition at line 566 of file juce_ReferenceCountedArray.h.

## ◆ insert() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | const ObjectClassPtr & | newObject
| ) |  |
| inline

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

Definition at line 410 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert().

## ◆ insert() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | ObjectClass * | newObject
| ) |  |
| inline

Inserts a new object into the array at the given index.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

This will increase the new object's reference count.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

See also
  add, addSorted, addIfNotAlreadyThere, set

Definition at line 387 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted().

## ◆ isEmpty()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty | ( |  | ) | const
| inlinenoexcept

Returns true if the array is empty, false otherwise.

Definition at line 156 of file juce_ReferenceCountedArray.h.

## ◆ minimiseStorageOverheads()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads | ( |  | ) |
| inlinenoexcept

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

Definition at line 849 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange().

## ◆ move()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::move | ( | int | currentIndex,
|  | int | newIndex
| ) |  |
| inlinenoexcept

Moves one of the objects to a different position.

This will move the object to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the object to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this object to end up. If this is less than zero, it will be moved to the end of the array

Definition at line 759 of file juce_ReferenceCountedArray.h.

## ◆ operator!=()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator!= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const
| inlinenoexcept

Compares this array to another one.

See also
  operator==

Definition at line 798 of file juce_ReferenceCountedArray.h.

## ◆ operator=() [1/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| inlinenoexcept

Copies another array into this one. Any existing objects in this array will first be released.

Definition at line 93 of file juce_ReferenceCountedArray.h.

## ◆ operator=() [2/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass >

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | const ReferenceCountedArray< OtherObjectClass, TypeOfCriticalSectionToUse > & | other | ) |
| inlinenoexcept

Copies another array into this one. Any existing objects in this array will first be released.

Definition at line 105 of file juce_ReferenceCountedArray.h.

## ◆ operator=() [3/3]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ReferenceCountedArray & juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| inlinenoexcept

Moves from another array

Definition at line 113 of file juce_ReferenceCountedArray.h.

## ◆ operator==()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator== | ( | const ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse > & | other | ) | const
| inlinenoexcept

Compares this array to another one.

Returns
  true only if the other array contains the same objects in the same order

Definition at line 787 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator!=().

## ◆ operator[]()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[] | ( | int | index | ) | const
| inlinenoexcept

Returns a pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

Definition at line 169 of file juce_ReferenceCountedArray.h.

## ◆ releaseObject()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

static void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::releaseObject | ( | ObjectClass * | o | ) |
| inlinestatic

Definition at line 900 of file juce_ReferenceCountedArray.h.

## ◆ remove()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove | ( | int | indexToRemove | ) |
| inline

Removes an object from the array.

This will remove the object at a given index and move back all the subsequent objects to close the gap.

If the index passed in is out-of-range, nothing will happen.

The object that is removed will have its reference count decreased, and may be deleted if not referenced from elsewhere.

Parameters

  indexToRemove | the index of the element to remove

See also
  removeObject, removeRange

Definition at line 606 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject().

## ◆ removeAndReturn()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClassPtr juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn | ( | int | indexToRemove | ) |
| inline

Removes and returns an object from the array.

This will remove the object at a given index and return it, moving back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen and a null pointer will be returned.

Parameters

  indexToRemove | the index of the element to remove

See also
  remove, removeObject, removeRange

Definition at line 630 of file juce_ReferenceCountedArray.h.

## ◆ removeLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast | ( | int | howManyToRemove = `1` | ) |
| inline

Removes the last n objects from the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  howManyToRemove | how many objects to remove from the end of the array

See also
  remove, removeObject, removeRange

Definition at line 719 of file juce_ReferenceCountedArray.h.

## ◆ removeObject() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | const ObjectClassPtr & | objectToRemove | ) |
| inline

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

Definition at line 671 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject().

## ◆ removeObject() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | ObjectClass * | objectToRemove | ) |
| inline

Removes the first occurrence of a specified object from the array.

If the item isn't found, no action is taken. If it is found, it is removed and has its reference count decreased.

Parameters

  objectToRemove | the object to try to remove

See also
  remove, removeRange

Definition at line 657 of file juce_ReferenceCountedArray.h.

## ◆ removeRange()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange | ( | int | startIndex,
|  | int | numberToRemove
| ) |  |
| inline

Removes a range of objects from the array.

This will remove a set of objects, starting from the given index, and move any subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

The objects that are removed will have their reference counts decreased, and may be deleted if not referenced from elsewhere.

Parameters

  startIndex | the index of the first object to remove
  numberToRemove | how many objects should be removed

See also
  remove, removeObject

Definition at line 688 of file juce_ReferenceCountedArray.h.

## ◆ set() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | const ObjectClassPtr & | newObject
| ) |  |
| inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

Definition at line 487 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set().

## ◆ set() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | ObjectClass * | newObject
| ) |  |
| inline

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

The object being added has its reference count increased, and if it's replacing another object, then that one has its reference count decreased, and may be deleted.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.

See also
  add, insert, remove

Definition at line 453 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addOrReplaceSorted().

## ◆ size()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::size | ( |  | ) | const
| inlinenoexcept

Returns the current number of objects in the array.

Definition at line 150 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty().

## ◆ sort()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class ElementComparator >

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort | ( | ElementComparator & | comparator,
|  | bool | retainOrderOfEquivalentItems = `false`
| ) |  |
| inlinenoexcept

Sorts the elements in the array.

This will use a comparator object to sort the elements into order. The object passed must have a method of the form:

int compareElements (ElementType first, ElementType second);

..and this method must return:

- a value of < 0 if the first comes before the second
- a value of 0 if the two objects are equivalent
- a value of > 0 if the second comes before the first

To improve performance, the compareElements() method can be declared as static or const.

Parameters

  comparator | the comparator to use for comparing elements.
  retainOrderOfEquivalentItems | if this is true, then items which the comparator says are equivalent will be kept in the order in which they currently appear in the array. This is slower to perform, but may be important in some cases. If it's false, a faster algorithm is used, but equivalent elements may be rearranged.

See also
  sortArray

Definition at line 831 of file juce_ReferenceCountedArray.h.

## ◆ swap()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap | ( | int | index1,
|  | int | index2
| ) |  |
| inlinenoexcept

Swaps a pair of objects in the array.

If either of the indexes passed in is out-of-range, nothing will happen, otherwise the two objects at these positions will be exchanged.

Definition at line 735 of file juce_ReferenceCountedArray.h.

## ◆ swapWith()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith | ( | OtherArrayType & | otherArray | ) |
| inlinenoexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

Definition at line 775 of file juce_ReferenceCountedArray.h.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator=().

## Member Data Documentation

## ◆ releaseAllObjects

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

JUCE_DEPRECATED_WITH_BODY(void swapWithArray(ReferenceCountedArray &other) noexcept, { swapWith(other);}) private void juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::releaseAllObjects()
| inline

Definition at line 888 of file juce_ReferenceCountedArray.h.

The documentation for this class was generated from the following file:

- juce_ReferenceCountedArray.h